IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'FORMULA_ORCA' AND
                 TYPE = 'P' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP PROCEDURE FORMULA_ORCA
GO

CREATE PROCEDURE FORMULA_ORCA (@P_NMTABELA       VARCHAR(20),
                               @P_CDFILIAL       VARCHAR(4),
                               @P_NRORCAEVENTO   VARCHAR(10),
                               @P_NRSEQORCAEVE   VARCHAR(2),
                               @P_CDARVPROD      VARCHAR(20),
                               @P_QTPRODUTO      DOUBLE PRECISION,
                               @P_CDMENSERRO     VARCHAR(20) OUTPUT)
AS
   DECLARE @V_CDPRODUTO       VARCHAR(10);
   DECLARE @V_NRTRUNO         VARCHAR(2);
   DECLARE @V_CDGRTOTAPROD    VARCHAR(3)
   DECLARE @V_VRITEPREBASE    DOUBLE PRECISION;
   DECLARE @V_VRCUSTO         DOUBLE PRECISION;
   DECLARE @V_NRITEM          DOUBLE PRECISION;
   DECLARE @V_CDGRUPPROD      VARCHAR(10);
   DECLARE @V_CDSUBGRPROD     VARCHAR(10);
   DECLARE @V_IDORIGPRUNITORE VARCHAR(1);
   DECLARE @V_VRPERACRITEMORC DOUBLE PRECISION;
   DECLARE @V_EXISTEGRUPO     VARCHAR(10);
BEGIN
   SET @P_CDMENSERRO = '';
   SET @V_EXISTEGRUPO = NULL;

   IF @P_NMTABELA = 'ITEMORCAEVEN' BEGIN

      SELECT @V_IDORIGPRUNITORE = IDORIGPRUNITORE, @V_VRPERACRITEMORC = VRPERACRITEMORC
      FROM PARAMORCAEVE;

      IF @V_IDORIGPRUNITORE = 'P' BEGIN

         DECLARE C_PROD CURSOR FOR
         SELECT PRODUTO.CDPRODUTO, ITEMPREBASE.VRITEPREBASE, PRODUTO.CDGRTOTAPROD
         FROM PRODUTO, ITEMPREBASE, ORCAEVENTO
         WHERE PRODUTO.CDARVPROD       = @P_CDARVPROD
           AND PRODUTO.CDPRODUTO       = ITEMPREBASE.CDPRODUTO
           AND ITEMPREBASE.CDPRECOBASE = ORCAEVENTO.CDPRECOBASE
           AND ORCAEVENTO.CDFILIAL     = @P_CDFILIAL
           AND ORCAEVENTO.NRORCAEVENTO = @P_NRORCAEVENTO
           AND ORCAEVENTO.NRSEQORCAEVE = @P_NRSEQORCAEVE
           AND NOT PRODUTO.CDPRODUTO IN (SELECT CDPRODUTO FROM ITEMORCAEVEN
                                         WHERE CDFILIAL     = @P_CDFILIAL
                                           AND NRORCAEVENTO = @P_NRORCAEVENTO
                                           AND NRSEQORCAEVE = @P_NRSEQORCAEVE);

         OPEN C_PROD;
         FETCH NEXT FROM C_PROD INTO @V_CDPRODUTO, @V_VRITEPREBASE, @V_CDGRTOTAPROD;

         SELECT DISTINCT
                @V_VRCUSTO = (TEKNISA.CUSTO_PRODUTO_LCEST(DEPARTAMENTO.CDFILIPEDORC, PRODUTO.CDPRODUTO, PARAMORCAEVE.CDTIPOCUSTO, GETDATE(), GETDATE(), A.CDALMOX, A.CDLOCAL, '', ''))
           FROM PRODUTO, PARAMORCAEVE, DEPARTAMENTO,
                (SELECT DISTINCT
                        PARAMFILIAL.CDFILIAL, PRODFILI.CDPRODUTO,
                        CASE PARAMFILIAL.IDUTILALMOX WHEN 'S' THEN ISNULL(PRODFILI.CDALMOXPRCLI, PARAMFILIAL.CDALMOXARIFE) ELSE ' ' END CDALMOX,
                        CASE PARAMFILIAL.IDUTILLCESTQ WHEN 'S' THEN ISNULL(PRODFILI.CDLOCALPRCLI, PARAMFILIAL.CDLOCALESTOQ) ELSE ' ' END CDLOCAL
                   FROM PRODFILI, PARAMFILIAL, PRODUTO, DEPARTAMENTO
                  WHERE PARAMFILIAL.CDFILIAL     = PRODFILI.CDFILIAL
                    AND PRODUTO.CDPRODUTO        = PRODFILI.CDPRODUTO
                    AND PRODUTO.CDDEPTPEDORC     = DEPARTAMENTO.CDDEPTO
                    AND PARAMFILIAL.CDFILIAL     = DEPARTAMENTO.CDFILIPEDORC) A
          WHERE PRODUTO.CDPRODUTO    = @V_CDPRODUTO
            AND DEPARTAMENTO.CDDEPTO = PRODUTO.CDDEPTPEDORC
            AND A.CDFILIAL           = DEPARTAMENTO.CDFILIPEDORC
            AND A.CDPRODUTO          = PRODUTO.CDPRODUTO;


         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_NRITEM = MAX(NRITEMORCEVE) + 1
            FROM ITEMORCAEVEN
            WHERE CDFILIAL = @P_CDFILIAL AND NRORCAEVENTO = @P_NRORCAEVENTO AND NRSEQORCAEVE  = @P_NRSEQORCAEVE;

            SELECT @V_EXISTEGRUPO = MAX(NV.CDSUBGRPROD)
              FROM PRODUTO PA, PRODUTO PB, PARAMORCAEVE PO, NVSUBGRPROD NV
             WHERE (PA.CDPRODUTO   = @V_CDPRODUTO)
               AND (NV.CDGRUPPROD  = PO.CDGRPRODRELORCA)
               AND (NV.CDFILISUBGR = 'P')
               AND (NV.CDPRODUTO   = PB.CDPRODUTO)
               AND (PA.CDARVPROD BETWEEN PB.CDARVPROD AND PB.CDARVPROD + 'zzzzzzzzzzzzzzzzzzzz')
               AND (LEN(PB.CDARVPROD) = (SELECT MAX(LEN(P1.CDARVPROD))
                                           FROM PRODUTO P1, PRODUTO P2, PARAMORCAEVE PR, NVSUBGRPROD SU
                                          WHERE (SU.CDGRUPPROD  = PR.CDGRPRODRELORCA)
                                            AND (SU.CDFILISUBGR = 'P')
                                            AND (SU.CDPRODUTO   = P1.CDPRODUTO)
                                            AND (P2.CDARVPROD BETWEEN P1.CDARVPROD AND P1.CDARVPROD + 'zzzzzzzzzzzzzzzzzzzz')
                                            AND (P2.CDPRODUTO = PA.CDPRODUTO)));

            IF @V_EXISTEGRUPO IS NULL BEGIN
               SET @P_CDMENSERRO = 'SEMGRUPO';
            END
            ELSE BEGIN
               SELECT @V_CDGRUPPROD  = NV.CDGRUPPROD,
                      @V_CDSUBGRPROD = NV.CDSUBGRPROD
                 FROM PRODUTO PA, PRODUTO PB, PARAMORCAEVE PO, NVSUBGRPROD NV
                WHERE (PA.CDPRODUTO   = @V_CDPRODUTO)
                  AND (NV.CDGRUPPROD  = PO.CDGRPRODRELORCA)
                  AND (NV.CDFILISUBGR = 'P')
                  AND (NV.CDPRODUTO   = PB.CDPRODUTO)
                  AND (PA.CDARVPROD BETWEEN PB.CDARVPROD AND PB.CDARVPROD + 'zzzzzzzzzzzzzzzzzzzz')
                  AND (LEN(PB.CDARVPROD) = (SELECT MAX(LEN(P1.CDARVPROD))
                                              FROM PRODUTO P1, PRODUTO P2, PARAMORCAEVE PR, NVSUBGRPROD SU
                                             WHERE (SU.CDGRUPPROD  = PR.CDGRPRODRELORCA)
                                               AND (SU.CDFILISUBGR = 'P')
                                               AND (SU.CDPRODUTO   = P1.CDPRODUTO)
                                               AND (P2.CDARVPROD BETWEEN P1.CDARVPROD AND P1.CDARVPROD + 'zzzzzzzzzzzzzzzzzzzz')
                                               AND (P2.CDPRODUTO = PA.CDPRODUTO)));
            END;

            INSERT INTO ITEMORCAEVEN
               (CDFILIAL,     NRORCAEVENTO, NRSEQORCAEVE, CDPRODUTO,
                QTITEMORCEVE, VRITEMORCEVE, CDGRTOTAPROD, NRITEMORCEVE,
                CDGRUPPRODREL, CDSUBGRPRODREL, VRCUSTOESTPROD)
            VALUES
               (@P_CDFILIAL,   @P_NRORCAEVENTO, @P_NRSEQORCAEVE, @V_CDPRODUTO,
                @P_QTPRODUTO,  @V_VRITEPREBASE, @V_CDGRTOTAPROD, REPLICATE('0', 10 - LEN(CONVERT(VARCHAR, @V_NRITEM))) + CONVERT(VARCHAR, @V_NRITEM),
                @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_VRCUSTO);

            FETCH NEXT FROM C_PROD INTO @V_CDPRODUTO, @V_VRITEPREBASE, @V_CDGRTOTAPROD;
         END;
         CLOSE C_PROD;
         DEALLOCATE C_PROD;
      END
      ELSE BEGIN
      --- Verifica o item adicionado quando esta parmetrizado para custo do produto ---

         DECLARE C_PROD CURSOR FOR
         SELECT DISTINCT A.CDPRODUTO, A.CDGRTOTAPROD,
                         (TEKNISA.CUSTO_PRODUTO_LCEST(A.CDFILIAL, A.CDPRODUTO, PARAMORCAEVE.CDTIPOCUSTO, GETDATE(), GETDATE(), B.CDALMOX, B.CDLOCAL, '', '')) VRCUSTO
           FROM PARAMORCAEVE, ORCAEVENTO,
                (SELECT PRODUTO.CDPRODUTO, PRODUTO.CDDEPTPEDORC,
                PRODUTO.CDGRTOTAPROD, DEPARTAMENTO.CDFILIPEDORC AS CDFILIAL, PRODUTO.CDARVPROD
                   FROM PRODUTO, DEPARTAMENTO
                  WHERE DEPARTAMENTO.CDDEPTO = PRODUTO.CDDEPTPEDORC) A
                 LEFT JOIN
                   (SELECT DISTINCT
                           PARAMFILIAL.CDFILIAL, PRODFILI.CDPRODUTO,
                           CASE PARAMFILIAL.IDUTILALMOX WHEN 'S' THEN ISNULL(PRODFILI.CDALMOXPRCLI, PARAMFILIAL.CDALMOXARIFE) ELSE ' ' END CDALMOX,
                           CASE PARAMFILIAL.IDUTILLCESTQ WHEN 'S' THEN ISNULL(PRODFILI.CDLOCALPRCLI, PARAMFILIAL.CDLOCALESTOQ) ELSE ' ' END CDLOCAL
                      FROM PRODFILI, PARAMFILIAL, PRODUTO, DEPARTAMENTO
                     WHERE PARAMFILIAL.CDFILIAL     = PRODFILI.CDFILIAL
                       AND PRODUTO.CDPRODUTO        = PRODFILI.CDPRODUTO
                       AND PRODUTO.CDDEPTPEDORC     = DEPARTAMENTO.CDDEPTO
                       AND PARAMFILIAL.CDFILIAL     = DEPARTAMENTO.CDFILIPEDORC) B
                        ON (A.CDPRODUTO = B.CDPRODUTO) AND
                           (A.CDFILIAL  = B.CDFILIAL)
          WHERE A.CDARVPROD       = @P_CDARVPROD
            AND ORCAEVENTO.CDFILIAL     = @P_CDFILIAL
            AND ORCAEVENTO.NRORCAEVENTO = @P_NRORCAEVENTO
            AND ORCAEVENTO.NRSEQORCAEVE = @P_NRSEQORCAEVE
            AND NOT A.CDPRODUTO IN (SELECT CDPRODUTO FROM ITEMORCAEVEN
                                     WHERE CDFILIAL     =  @P_CDFILIAL
                                       AND NRORCAEVENTO =  @P_NRORCAEVENTO
                                       AND NRSEQORCAEVE =  @P_NRSEQORCAEVE)

         OPEN C_PROD;
         FETCH NEXT FROM C_PROD INTO @V_CDPRODUTO, @V_CDGRTOTAPROD, @V_VRCUSTO

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_NRITEM = MAX(NRITEMORCEVE) + 1
            FROM ITEMORCAEVEN
            WHERE CDFILIAL = @P_CDFILIAL AND NRORCAEVENTO = @P_NRORCAEVENTO AND NRSEQORCAEVE  = @P_NRSEQORCAEVE;

            SELECT @V_EXISTEGRUPO = MAX(NV.CDSUBGRPROD)
              FROM PRODUTO PA, PRODUTO PB, PARAMORCAEVE PO, NVSUBGRPROD NV
             WHERE (PA.CDPRODUTO   = @V_CDPRODUTO)
               AND (NV.CDGRUPPROD  = PO.CDGRPRODRELORCA)
               AND (NV.CDFILISUBGR = 'P')
               AND (NV.CDPRODUTO   = PB.CDPRODUTO)
               AND (PA.CDARVPROD BETWEEN PB.CDARVPROD AND PB.CDARVPROD + 'zzzzzzzzzzzzzzzzzzzz')
               AND (LEN(PB.CDARVPROD) = (SELECT MAX(LEN(P1.CDARVPROD))
                                           FROM PRODUTO P1, PRODUTO P2, PARAMORCAEVE PR, NVSUBGRPROD SU
                                          WHERE (SU.CDGRUPPROD  = PR.CDGRPRODRELORCA)
                                            AND (SU.CDFILISUBGR = 'P')
                                            AND (SU.CDPRODUTO   = P1.CDPRODUTO)
                                            AND (P2.CDARVPROD BETWEEN P1.CDARVPROD AND P1.CDARVPROD + 'zzzzzzzzzzzzzzzzzzzz')
                                            AND (P2.CDPRODUTO = PA.CDPRODUTO)));

            IF @V_EXISTEGRUPO IS NULL BEGIN
               SET @P_CDMENSERRO = 'SEMGRUPO';
            END
            ELSE BEGIN
               SELECT @V_CDGRUPPROD  = NV.CDGRUPPROD,
                      @V_CDSUBGRPROD = NV.CDSUBGRPROD
                 FROM PRODUTO PA, PRODUTO PB, PARAMORCAEVE PO, NVSUBGRPROD NV
                WHERE (PA.CDPRODUTO   = @V_CDPRODUTO)
                  AND (NV.CDGRUPPROD  = PO.CDGRPRODRELORCA)
                  AND (NV.CDFILISUBGR = 'P')
                  AND (NV.CDPRODUTO   = PB.CDPRODUTO)
                  AND (PA.CDARVPROD BETWEEN PB.CDARVPROD AND PB.CDARVPROD + 'zzzzzzzzzzzzzzzzzzzz')
                  AND (LEN(PB.CDARVPROD) = (SELECT MAX(LEN(P1.CDARVPROD))
                                              FROM PRODUTO P1, PRODUTO P2, PARAMORCAEVE PR, NVSUBGRPROD SU
                                             WHERE (SU.CDGRUPPROD  = PR.CDGRPRODRELORCA)
                                               AND (SU.CDFILISUBGR = 'P')
                                               AND (SU.CDPRODUTO   = P1.CDPRODUTO)
                                               AND (P2.CDARVPROD BETWEEN P1.CDARVPROD AND P1.CDARVPROD + 'zzzzzzzzzzzzzzzzzzzz')
                                               AND (P2.CDPRODUTO = PA.CDPRODUTO)));
            END;

            INSERT INTO ITEMORCAEVEN
               (CDFILIAL,     NRORCAEVENTO, NRSEQORCAEVE, CDPRODUTO,
                QTITEMORCEVE, VRITEMORCEVE, CDGRTOTAPROD, NRITEMORCEVE,
                CDGRUPPRODREL, CDSUBGRPRODREL, VRCUSTOESTPROD)
            VALUES
               (@P_CDFILIAL,   @P_NRORCAEVENTO, @P_NRSEQORCAEVE, @V_CDPRODUTO,
                @P_QTPRODUTO,  @V_VRCUSTO + ((@V_VRCUSTO * @V_VRPERACRITEMORC) / 100), @V_CDGRTOTAPROD, REPLICATE('0', 10 - LEN(CONVERT(VARCHAR, @V_NRITEM))) + CONVERT(VARCHAR, @V_NRITEM),
                @V_CDGRUPPROD, @V_CDSUBGRPROD, @V_VRCUSTO);

            FETCH NEXT FROM C_PROD INTO @V_CDPRODUTO, @V_VRCUSTO, @V_CDGRTOTAPROD;
         END;
         CLOSE C_PROD;
         DEALLOCATE C_PROD;

      END;
   END
   ELSE BEGIN
      IF @P_NMTABELA = 'ITMAOOBRAORCA' BEGIN
         DECLARE C_PRODMAO CURSOR FOR
         SELECT PRODUTO.CDPRODUTO, ITEMPREBASE.VRITEPREBASE, PRODUTO.CDGRTOTAPROD
         FROM PRODUTO, ITEMPREBASE, ORCAEVENTO
         WHERE PRODUTO.CDARVPROD       = @P_CDARVPROD
           AND PRODUTO.CDPRODUTO       = ITEMPREBASE.CDPRODUTO
           AND ITEMPREBASE.CDPRECOBASE = ORCAEVENTO.CDPREBAMOBRA
           AND ORCAEVENTO.CDFILIAL     = @P_CDFILIAL
           AND ORCAEVENTO.NRORCAEVENTO = @P_NRORCAEVENTO
           AND ORCAEVENTO.NRSEQORCAEVE = @P_NRSEQORCAEVE
           AND NOT PRODUTO.CDPRODUTO IN (SELECT CDPRODUTO FROM ITMAOOBRAORCA
                                         WHERE CDFILIAL     = @P_CDFILIAL
                                           AND NRORCAEVENTO = @P_NRORCAEVENTO
                                           AND NRSEQORCAEVE = @P_NRSEQORCAEVE);

         OPEN C_PRODMAO;
         FETCH NEXT FROM C_PRODMAO INTO @V_CDPRODUTO, @V_VRITEPREBASE, @V_CDGRTOTAPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            DECLARE C_TURNO CURSOR FOR
            SELECT DISTINCT NRTURNO FROM ITMAOOBRAORCA
            WHERE CDFILIAL     = @P_CDFILIAL
              AND NRORCAEVENTO = @P_NRORCAEVENTO
              AND NRSEQORCAEVE = @P_NRORCAEVENTO;

            OPEN C_TURNO;
            FETCH NEXT FROM C_TURNO INTO @V_NRTRUNO;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               INSERT INTO ITMAOOBRAORCA
                  (CDFILIAL,    NRORCAEVENTO, NRSEQORCAEVE, CDPRODUTO,
                   QTPRODMOBRA, VRCOBRMOBRA,  NRTURNO,      CDGRTOTAPROD)
               VALUES
                  (@P_CDFILIAL,  @P_NRORCAEVENTO, @P_NRSEQORCAEVE, @V_CDPRODUTO,
                   @P_QTPRODUTO, @V_VRITEPREBASE, @V_NRTRUNO,      @V_CDGRTOTAPROD);
            END;
            CLOSE C_TURNO;
            DEALLOCATE C_TURNO;

            FETCH NEXT FROM C_PRODMAO INTO @V_CDPRODUTO, @V_VRITEPREBASE, @V_CDGRTOTAPROD;
         END;
         CLOSE C_PRODMAO;
         DEALLOCATE C_PRODMAO;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'FORMULA_ORCA','5.40.000';
GO

